unit eBob42.DCon2003;
interface
uses
  System.Web.UI,
  System.Web.UI.WebControls;

type
  WebFormDCon2003 = class(System.Web.UI.Page)
    ddlFirst, ddlSecond: DropDownList;
    cbSpeaker: CheckBox;
    ddlSpeaker: DropDownList;
    btnAgenda: Button;
    lbDCon, lbError, lbOutput: System.Web.UI.WebControls.Label;
  protected
    procedure btnAgendaClick(Sender: System.Object; E: EventArgs);
  public
    procedure Page_Load(Sender: System.Object; E: EventArgs);
  end;

implementation
uses
  Borland.Delphi.Classes,
  Borland.Delphi.SysUtils,
  Borland.Delphi.IniFiles,
  eBob42.Planning;

  procedure WebFormDCon2003.Page_Load(Sender: System.Object; E: EventArgs);
  var
    Speaker: TStringList;
    Topics,Speakers,i: Integer;
    Topic: String;
  begin
    if not IsPostBack then
    begin
      lbDCon.Text := '<table border=1 cellpadding=3 cellspacing=0><tr bgcolor="ffffaf">' +
        '<th align="center" valign="bottom"><font face="arial" size=2 color=red>' +
        '<a href="http://www.dcon.co.uk/index.htm"target=_DCon><img src="/gif/dc2k1s2.gif" border=0 align=left></a>'+
        '&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<a href="http://www.dcon.co.uk/intro.php"target=_DCon>Overview</a>'+
        '&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<a href="http://www.dcon.co.uk/sessions.php"target=_DCon>Sessions</a>'+
        '&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<a href="http://www.dcon.co.uk/speakers.php"target=_DCon>Speakers</a>'+
        '&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<a href="http://www.dcon.co.uk/book.php"target=_DCon>Costs &amp; Booking</a>'+
        '&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<a href="http://www.dcon.co.uk/contacts.php"target=_DCon>Contacts</a>'+
        '&nbsp;</th></tr></table>';
      lbError.Text := 'Welcome to the DCon 2003 Session Schedule Planner';
      with TIniFile.Create('F:\Domains\eBob42.com\html\_private\DCon2003.ini') do
      try
        Topics := ReadInteger('topics', 'topics', 0);
        for i:=0 to Pred(Topics) do
        begin
          Topic := ReadString('topics', Format('topic%.d', [i]), '');
          ddlFirst.Items.Add(Topic);
          ddlSecond.Items.Add(Topic)
        end;
        Speakers := ReadInteger('speakers', 'speakers', 0);
        Speaker := TStringList.create;
        Speaker.Sorted := True;
        for i:=0 to Pred(Speakers) do
          Speaker.Add(ReadString('speakers', Format('speaker%.d', [i]), ''));
        for i:=0 to Pred(Speakers) do
          ddlSpeaker.Items.Add(Speaker[i]);
        Speaker.Free;
      finally
        Free // TIniFile
      end;
    end;
    btnAgenda.Add_Click(Self.btnAgendaClick) // event handler
  end;

  procedure WebFormDCon2003.btnAgendaClick(Sender: System.Object; E: EventArgs);
  var
    IniFile: TIniFile;
    DCon: TDCon;
    Str: String;
    i,j: Integer;
    Nosel: Boolean;
  begin
    lbError.Text := 'Not implemented, yet.';
    try
      IniFile := TIniFile.Create('F:\Domains\eBob42.com\html\_private\DCon2003.ini');
      i := Succ(IniFile.ReadInteger('slots', 'agendax', 0));
      IniFile.WriteInteger('slots', 'agendax', i);
      IniFile.UpdateFile; // just in case...
      try
        DCon := TDCon.Create(IniFile);
        try
          if cbSpeaker.Checked then
            Str := ddlSpeaker.SelectedItem.ToString
          else Str := '';
          lbError.Text := 'Welcome ' + Str;
          DCon.GeneratePlanning(ddlFirst.SelectedIndex, ddlSecond.SelectedIndex, Str);
          Nosel := False;
          Str := '<table border="1">' +
            '<tr><td colspan="5" bgcolor="darkred" align="center"><font face="verdana" size="2" color="white"><b>Monday, 9 June 2003</td></tr>' +
            '<tr><td bgcolor="white" align="center"><font face="verdana" size="2" nowrap><b>Time</td>' +
                '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Room</td>' +
                '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Session Title</td>' +
                '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Speaker</td>' +
                '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Level</td></tr>';
          for i:=0 to Pred(DCon.Timeslots) do
          begin
            case i of
              0: Str := Str + '<tr bgcolor="f7e6d5">' +
                   '<td align="right"><font face="verdana" size="2" nowrap>9:00am-9:15am</td>' + // Time
                   '<td align="center"><font face="verdana" size="2">1</td>' + // Room
                   '<td><font face="verdana" size="2"><b>Welcome</td>' + // Session
                   '<td>&nbsp;</td>' + // Speaker
                   '<td>&nbsp;</td>' + // Level
                   '</tr>';
              1: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>10:30am-10:50am</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Tea/Coffee in the Exhibition area</td>' +
                   '</tr>';
              2: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>12:05pm-1:35pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Lunch</td>' +
                   '</tr>';
              3: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>2:50pm-3:10pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Tea/Coffee in the Exhibition area</td>' +
                   '</tr>';
              4: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>4:25pm-4:45pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Tea/Coffee in the Exhibition area</td>' +
                   '</tr>';
              5: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>6:00pm-6:15pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Free time</td>' +
                   '</tr>';
              6: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>7:45pm-9:30pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Conference dinner</td>' +
                   '</tr>';
              7: Str := Str + '<tr><td colspan="5">&nbsp;</td></tr>' +
                   '<tr><td colspan="5" bgcolor="darkred" align="center"><font face="verdana" size="2" color="white"><b>Tuesday, 10 June 2003</center></td></tr>' +
                   '<tr><td bgcolor="white" align="center"><font face="verdana" size="2" nowrap><b>Time</td>' +
                   '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Room</td>' +
                   '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Session Title</td>' +
                   '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Speaker</td>' +
                   '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>Level</td></tr>';
              8: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>10:30am-10:50am</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Tea/Coffee in the Exhibition area</td>' +
                   '</tr>';
              9: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>12:05pm-1:35pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Lunch</td>' +
                   '</tr>';
             10: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>2:50pm-3:10pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Tea/Coffee in the Exhibition area</td>' +
                   '</tr>';
             11: Str := Str + '<tr>' +
                   '<td align="right"><font face="verdana" size="2" nowrap>4:25pm-4:45pm</td>' + // Time
                   '<td align="center" colspan="4"><font face="verdana" size="2">Tea/Coffee in the Exhibition area</td>' +
                   '</tr>';
            end;
            if Assigned(DCon.Timeslot[i]) then
              if DCon.Timeslot[i].Sessions > 0 then
              begin
                j := DCon.Timeslot[i].Index[0];
                if (i in [0,5]) or (DCon.Timeslot[i].Session[j].SessionScore > $2) then
                  Str := Str + '<tr bgcolor="f7e6d5">'
                else
                  Str := Str + '<tr bgcolor="d5e6f7">';
                Str := Str + '<td align="right"><font face="verdana" size="2" nowrap>' + DCon.Timeslot[i].Time + '</td>';
                if (i in [0,5]) or (DCon.Timeslot[i].Session[j].SessionScore > $2) then
                  Str := Str + '<td align="center"><font face="verdana" size="2">' + 
                    IntToStr(DCon.Timeslot[i].Session[j].Room) + '</td>'
                else
                begin
                  Nosel := True;
                  Str := Str + '<td align="center" bgcolor="f7e6d5"><font face="verdana" size="2">' + 
                    IntToStr(DCon.Timeslot[i].Session[j].Room) + '* </td>'
                end;
                Str := Str + Format('<td><font face="verdana" size="2"><b><a href="http://www.dcon.co.uk/talks/sess%.2d.php"target=_DCon>%s</a></td>',
                     [DCon.Timeslot[i].Session[j].ID,DCon.Timeslot[i].Session[j].Title]);
                Str := Str + '<td align="center"><font face="verdana" size="2"><b>' + DCon.Timeslot[i].Session[j].Speaker + '</td>';
                if i in [0,5] then
                  Str := Str + '<td align="right"><font face="verdana" size="2">All</td>'
                else
                  Str := Str + '<td align="right"><font face="verdana" size="2">' + DCon.Level[DCon.Timeslot[i].Session[j].Level] + '</td>';
                Str := Str + '</tr>'
              end
          end {for};
          Str := Str + '<tr>' +
            '<td align="right"><font face="verdana" size="2" nowrap>6:00pm</td>' + // Time
            '<td align="center" colspan="4"><font face="verdana" size="2">Conference close</td>' +
            '</tr>' +
            '</table>';
          if Nosel then
          begin
            Str := Str + '<p><font size=1>';
            Str := Str + '* Note: in some timeslots, no session selection could be made based on your preferences. In those situations, <br>';
            Str := Str + 'we''ve selected the session in the biggest room, and you should make your own choice from the <a href="http://www.dcon.co.uk/sessions.php"target=_DCon>list of sessions</a>.</font>'
          end;
          lbOutput.Text := Str;
        finally
          DCon.Free
        end
      finally
        IniFile.Free
      end
    except
      on E: Exception do
        lbError.Text := E.ClassName + ' Error: ' + E.Message
    end
  end;

end.